#include <memory>
#include <iostream>

struct thing {
	thing() { std::cout << "constructed\n"; }
	~thing() { std::cout << "destroyed\n"; }
	thing(const thing&) = delete;
	thing(thing&&) = delete;
	thing& operator=(const thing&) = delete;
	thing& operator=(thing&&) = delete;
};

void bad_uptr() {
	auto ptr1 = std::make_unique<thing>();
	auto* raw = ptr1.get();
	std::unique_ptr<thing> ptr2{ raw };
	// bad things happen now
}

void bad_sptr() {
	auto ptr1 = std::make_shared<thing>();
	auto* raw = ptr1.get();
	std::shared_ptr<thing> ptr2{ raw };
}

int main() {
	// bad_uptr();
	// bad_sptr();
}
