#include <cassert>
#include <set>
#include <map>
#include <vector>
#include <iostream>

void print(auto x) {
	std::cout << x << '\n';
}

int main() {
	std::vector vec = { 'a', 'b', 'c', 'd' };
	std::set s = { 7, 17, 42, 1337 };
	std::map<char, int> m = { { 'a', 1 }, { 'c', 3 }, { 'z', -1 } };

	auto vi = vec.begin() + 2;

	print(*vi);
	vi -= 2;
	print(*vi);
	vi += 4;
	assert(vi == vec.end());

	auto si = s.begin();

	// si += 2;  // error, not random-access
	++si;
	print(*si);

	auto mi = m.end();

	// mi -= 2;  // error, not random-access
	--mi;

	print(mi->first);
	print(mi->second);
}
