#include <iostream>

struct point {
	int x = 0, y = 0;
	point() { std::cout << "constructor\n"; }
	point(int x, int y) : x(x), y(y) {
		std::cout << " constructor with arguments: "
		          << x << ", " << y << '\n';
	}
	~point() {
		std::cout << '(' << x << ", " << y << ") destructor\n";
	}
};

int main() {
	int* ptr1 = new int;    // uninitialised!
	int* ptr2 = new int{ 17 };
	int* ptr3 = new int{};  // initialised to zero

	std::cout << *ptr1 << ' '  // run valgrind
	          << *ptr2 << ' '
	          << *ptr3 << '\n';

	auto* ptr4 = new point;  // calls point()
	auto* ptr5 = new point{ 4, 2 };

	std::cout << "---\n";
	delete ptr5;
	delete ptr4;
	delete ptr3;
	delete ptr2;
	delete ptr1;
}
