#include <iostream>

// no dynamic allocation yet, just to show how a simple iterator is made

struct node {
	int value;
	node* next = nullptr;
};

struct list_iter {
	node* current;
	int& operator*() const { return current->value; }
	list_iter& operator++() {
		current = current->next;
		return *this;
	}
	// use pointer comparison
	friend bool operator==(list_iter, list_iter) = default;
};

struct list {
	node* first = nullptr;

	list_iter begin() { return { first }; }
	list_iter end() { return { nullptr }; }
};

int main() {
	node n1 = { 1 }, n2 = { 2 }, n3 = { 3 }, n4 = { 4 };
	n1.next = &n2;
	n2.next = &n4;
	n4.next = &n3;
	list lst = { &n1 };

	for (int x : lst) {
		std::cout << x << '\n';
	}

	auto it = lst.begin();
	++it;
	*it = 17;

	std::cout << "---\n" << n2.value << '\n';
}
