#include <iostream>
#include <memory>

struct thing {
	thing() { std::cout << "thing created\n"; }
	~thing() { std::cout << "thing destroyed\n"; }
	void do_something() {
		std::cout << "thing does something\n";
	}
};

int main() {
	std::weak_ptr<thing> wp;
	{
		auto sp = std::make_shared<thing>();
		std::cout << "inner block\n";
		wp = sp;

		// we cannot do this:
		// wp->do_something();

		if (auto ptr = wp.lock()) {
			ptr->do_something();
		}
	}

	if (auto ptr = wp.lock()) {
		ptr->do_something();
	} else {
		std::cout << "The weak pointer has expired.\n";
	}
}
